// pages/addinput/addinput.js
const app = getApp();
const { axios } = app.globalData;
Page({

  /**
   * 页面的初始数据
   */
  data: {
    formData: [
      { label: "姓名", name: "name", value: "", errmsg: "姓名不能为空！", require: true, placeholder: "请输入姓名" },
      { label: "姓别", name: "sex", type: "radio", value: 2, arr: [{ type: "男", value: 2 }, { type: "女", value: 1 }] },
      {
        label: "年级", name: "grade", type: 'picker', rule: "picker", value: "", key: "福建", data: {}, datas: [], columns: [], col: 3, require: true, errmsg: "年级不能为空"
      },
    ],
  },
  // 挑选地址
  choose () {
    this.setData({ show: false })
  },
  // 默认
  onChange (e) {
    let { updata } = this.data;
    updata["lock"] = e.detail;
    this.setData({
      updata
    });
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    let { data } = options, put = null, { formData } = this.data;
    if (!!data) {
      put = JSON.parse(data).updata;
      formData[0]["value"] = put.name;
      formData[1]["value"] = put.gender;
      formData[2]["value"] = put.address;
      formData[2]["values"] = put.grade;
      this.setData({ formData, id: put.id })
    }
    wx.lxd.Ctr({
      // nav
      title: !!data ? "修改" : "新增", //标题
      back: true,//返回按钮，tabber必须false（除非会改）
    })
    let that = this;
    wx.lxd.Form({
      Success (data) {
        let name = data[0]["value"], gender = data[1]["value"];
        let grade = JSON.parse(JSON.stringify(data[2])), { datas, values } = grade;
        let i = -1;
        datas[0].forEach((item, index) => {
          if (JSON.stringify(item.sort()) == JSON.stringify(values.sort())) {
            i = index;
          }
        })
        let school = datas[1][i][0], classes = datas[1][i][2];
        axios({
          url: !put ? "/option/student/" : `/option/student/${that.data.id}/`,
          method: !put ? "post" : 'put',
          data: {
            school,
            classes,
            name,
            gender,
          },
          success (res) {
            wx.navigateBack({
              delta: 1, // 回退前 delta(默认为1) 页面
            })
          }
        })
      }
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    let { formData } = this.data, keya = '', keyb = '', that = this;
    //  年级
    axios({
      url: "/option/school_tree/",
      method: 'get',
      success (res) {
        let { data } = res.data, obj = {}, objs = [[], []];
        data.forEach((item, index) => {
          index == 0 ? keya = item.title : '';
          obj[item["title"]] = {};
          item["children"].forEach((it, ind) => {
            ind == 0 ? keyb = it.title : "";
            obj[item["title"]][it["title"]] = [];
            it["children"].forEach(em => {
              objs[0].push([item.title, it.title, em.title]);
              objs[1].push([item.id, it.id, em.id]);
              obj[item["title"]][it["title"]].push(em.title);
            })
          })
        })
        formData[2]["data"] = obj,
          formData[2]["datas"] = objs,
          formData[2]["columns"] = [{
            values: Object.keys(obj),
            className: '学校',
          },
          {
            values: Object.keys(obj[keya]),
            className: '年级',
          },
          {
            values: obj[keya][keyb],
            className: '班级',
          }];
        that.setData({ formData })
      }
    })
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

})