// pages/leaveadd/leaveadd.js
const app = getApp();
const { axios } = app.globalData;
Page({

  /**
   * 页面的初始数据
   */
  data: {
    active: 0,
    submitobj: {},
    orderarr: [],
    msg: '',//暂无可请假的内容
  },
  // 挑选
  CheckboxonChange (e) {
    let { id } = e.currentTarget.dataset;
    let { submitobj } = this.data;
    submitobj[id] = e.detail;
    this.setData({
      submitobj
    })
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    wx.lxd.Ctr({
      // nav
      title: "请假申请", //标题
      back: true,//返回按钮，tabber必须false（除非会改）
    });
  },
  // 挑选地址
  ChooseAddress () {
    wx.navigateTo({
      url: `/pages/adddata/adddata?data=${JSON.stringify({ source: 'leaveadd' })}`,
    })
  },
  // 提交
  submit () {
    if (!!this.data.submitlock) return false;
    let { useraddress, submitobj } = this.data;
    if (!useraddress.id) {
      wx.showToast({
        title: '请选择学生',
        icon: "error"
      })
      return false;
    }
    delete submitobj["key"];
    if (JSON.stringify(submitobj) == "{}") {
      wx.showToast({
        title: '请选择请假日期',
        icon: "error"
      })
      return false;
    }
    this.setData({ submitlock: true })
    axios({
      url: '/order/student_leave/',
      method: 'post',
      data: {
        student: useraddress.id,
        leave_dates: JSON.stringify(submitobj),
      },
      success (res) {
        wx.navigateBack({
          delta: 1, // 回退前 delta(默认为1) 页面
        })
      }
    })
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    let { useraddress } = app.globalData, datas = [], type = [], that = this;
    if (!useraddress.id) {
      useraddress["name"] = ""
    } else {
      axios({
        url: `/order/student_leave/get_info/?student=${useraddress.id}`,
        method: "get",
        success (res) {
          let { data } = res.data, { lead_dates, orders } = data, datas = {}, orderarr = [], submitobj = {};
          if (orders.length == 0) {
            that.setData({
              msg: "暂无可请假的内容!"
            })
            return false;
          }
          type = orders;
          for (let key in lead_dates) {
            let arr = [];
            submitobj["key"] = [];
            Array.from(lead_dates[key]).forEach(item => {
              item = item.replace(/\(/, '？');
              item = item.replace(/\)/, '？');
              item = item.split("？").splice(0, 2);
              arr.push(item);
            })
            datas[key] = arr;
          }
          orders.forEach(item => {
            orderarr.push({
              id: item.id,
              name: item.name,
              list: datas[item.id]
            })
          })
          that.setData({ orderarr, submitobj })
        }
      })
    }
    this.setData({ useraddress })
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {
    this.setData({
      orderarr: []
    })
  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {
    app.globalData.useraddress = {};
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },
})